From 598dcad021afb25605595c29d583a04ea52bf653 Mon Sep 17 00:00:00 2001
From: "Gabriel F. T. Gomes" <gftg@linux.vnet.ibm.com>
Date: Wed, 7 Dec 2016 16:19:11 -0200
Subject: [PATCH] Make w_log1p type-generic

This patch converts the wrapper log1p (which set errno directly rather
than doing anything with __kernel_standard) to use the type-generic
template machinery, in the same way that has been done for ilogb.

Tested for powerpc64le, s390, and x86_64.

2016-12-06  Gabriel F. T. Gomes  <gftg@linux.vnet.ibm.com>

	* math/Makefile (gen-libm-calls): Add w_log1pF.
	(libm-calls): Remove w_log1pF.
	* math/w_log1p.c: Remove.
	* math/w_log1pf.c: Likewise.
	* math/w_log1pl.c: Likewise.
	* math/w_log1p_template.c: New file with type-generic
	implementation based on math/w_log1p.c.
	* sysdeps/ieee754/ldbl-128ibm/w_log1pl.c: Remove.
	* sysdeps/ieee754/ldbl-64-128/w_log1pl.c: Likewise.
---
 math/Makefile                          |  5 +++--
 math/w_log1p.c                         | 41 ----------------------------------
 math/w_log1p_template.c                | 36 +++++++++++++++++++++++++++++
 math/w_log1pf.c                        | 36 -----------------------------
 math/w_log1pl.c                        | 36 -----------------------------
 sysdeps/ieee754/ldbl-128ibm/w_log1pl.c | 23 -------------------
 sysdeps/ieee754/ldbl-64-128/w_log1pl.c | 23 -------------------
 7 files changed, 39 insertions(+), 161 deletions(-)
 delete mode 100644 math/w_log1p.c
 create mode 100644 math/w_log1p_template.c
 delete mode 100644 math/w_log1pf.c
 delete mode 100644 math/w_log1pl.c
 delete mode 100644 sysdeps/ieee754/ldbl-128ibm/w_log1pl.c
 delete mode 100644 sysdeps/ieee754/ldbl-64-128/w_log1pl.c

diff --git a/math/Makefile b/math/Makefile
index 848b093..50ce418 100644
--- a/math/Makefile
+++ b/math/Makefile
@@ -52,7 +52,8 @@ gen-libm-calls = cargF conjF cimagF crealF cabsF s_cacosF		  \
 		 k_casinhF s_csinhF k_casinhF s_csinhF s_catanhF s_catanF \
 		 s_ctanF s_ctanhF s_cexpF s_clogF s_cprojF s_csqrtF	  \
 		 s_cpowF s_clog10F s_fdimF s_nextdownF s_fmaxF s_fminF	  \
-		 s_nanF s_iseqsigF s_canonicalizeF w_ilogbF w_llogbF
+		 s_nanF s_iseqsigF s_canonicalizeF w_ilogbF w_llogbF	  \
+		 w_log1pF
 
 libm-calls =								  \
 	e_acosF e_acoshF e_asinF e_atan2F e_atanhF e_coshF e_expF e_fmodF \
@@ -61,7 +62,7 @@ libm-calls =								  \
 	e_ilogbF							  \
 	k_cosF k_sinF k_tanF s_asinhF s_atanF s_cbrtF			  \
 	s_ceilF s_cosF s_erfF s_expm1F s_fabsF				  \
-	s_floorF s_log1pF w_log1pF s_logbF				  \
+	s_floorF s_log1pF s_logbF				  \
 	s_nextafterF s_nexttowardF s_rintF s_scalblnF w_scalblnF	  \
 	s_significandF s_sinF s_tanF s_tanhF w_acosF w_acoshF w_asinF	  \
 	w_atan2F w_atanhF w_coshF w_expF w_exp2F w_exp10F w_fmodF	  \
diff --git a/math/w_log1p.c b/math/w_log1p.c
deleted file mode 100644
index 282c85c..0000000
--- a/math/w_log1p.c
+++ /dev/null
@@ -1,41 +0,0 @@
-/* Wrapper for __log1p that handles setting errno.
-   Copyright (C) 2015-2016 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, see
-   <http://www.gnu.org/licenses/>.  */
-
-#include <errno.h>
-#include <math.h>
-#include <math_private.h>
-
-double
-__w_log1p (double x)
-{
-  if (__glibc_unlikely (islessequal (x, -1.0)))
-    {
-      if (x == -1.0)
-	__set_errno (ERANGE);
-      else
-	__set_errno (EDOM);
-    }
-
-  return __log1p (x);
-}
-weak_alias (__w_log1p, log1p)
-
-#ifdef NO_LONG_DOUBLE
-strong_alias (__w_log1p, __log1pl)
-weak_alias (__w_log1p, log1pl)
-#endif
diff --git a/math/w_log1p_template.c b/math/w_log1p_template.c
new file mode 100644
index 0000000..1ac3450
--- /dev/null
+++ b/math/w_log1p_template.c
@@ -0,0 +1,36 @@
+/* Wrapper for __log1p that handles setting errno.
+   Copyright (C) 2015-2016 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <http://www.gnu.org/licenses/>.  */
+
+#include <errno.h>
+#include <math.h>
+#include <math_private.h>
+
+FLOAT
+M_DECL_FUNC (__w_log1p) (FLOAT x)
+{
+  if (__glibc_unlikely (islessequal (x, M_LIT (-1.0))))
+    {
+      if (x == -1)
+	__set_errno (ERANGE);
+      else
+	__set_errno (EDOM);
+    }
+
+  return M_SUF (__log1p) (x);
+}
+declare_mgen_alias (__w_log1p, log1p)
diff --git a/math/w_log1pf.c b/math/w_log1pf.c
deleted file mode 100644
index ed9992a..0000000
--- a/math/w_log1pf.c
+++ /dev/null
@@ -1,36 +0,0 @@
-/* Wrapper for __log1pf that handles setting errno.
-   Copyright (C) 2015-2016 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, see
-   <http://www.gnu.org/licenses/>.  */
-
-#include <errno.h>
-#include <math.h>
-#include <math_private.h>
-
-float
-__w_log1pf (float x)
-{
-  if (__glibc_unlikely (islessequal (x, -1.0f)))
-    {
-      if (x == -1.0f)
-	__set_errno (ERANGE);
-      else
-	__set_errno (EDOM);
-    }
-
-  return __log1pf (x);
-}
-weak_alias (__w_log1pf, log1pf)
diff --git a/math/w_log1pl.c b/math/w_log1pl.c
deleted file mode 100644
index 3478c1c..0000000
--- a/math/w_log1pl.c
+++ /dev/null
@@ -1,36 +0,0 @@
-/* Wrapper for __log1pl that handles setting errno.
-   Copyright (C) 2015-2016 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, see
-   <http://www.gnu.org/licenses/>.  */
-
-#include <errno.h>
-#include <math.h>
-#include <math_private.h>
-
-long double
-__w_log1pl (long double x)
-{
-  if (__glibc_unlikely (islessequal (x, -1.0L)))
-    {
-      if (x == -1.0L)
-	__set_errno (ERANGE);
-      else
-	__set_errno (EDOM);
-    }
-
-  return __log1pl (x);
-}
-weak_alias (__w_log1pl, log1pl)
diff --git a/sysdeps/ieee754/ldbl-128ibm/w_log1pl.c b/sysdeps/ieee754/ldbl-128ibm/w_log1pl.c
deleted file mode 100644
index 969fadc..0000000
--- a/sysdeps/ieee754/ldbl-128ibm/w_log1pl.c
+++ /dev/null
@@ -1,23 +0,0 @@
-/* Wrapper for __log1pl that handles setting errno.
-   Copyright (C) 2015-2016 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, see
-   <http://www.gnu.org/licenses/>.  */
-
-#include <math_ldbl_opt.h>
-#undef weak_alias
-#define weak_alias(n,a)
-#include <math/w_log1pl.c>
-long_double_symbol (libm, __w_log1pl, log1pl);
diff --git a/sysdeps/ieee754/ldbl-64-128/w_log1pl.c b/sysdeps/ieee754/ldbl-64-128/w_log1pl.c
deleted file mode 100644
index 969fadc..0000000
--- a/sysdeps/ieee754/ldbl-64-128/w_log1pl.c
+++ /dev/null
@@ -1,23 +0,0 @@
-/* Wrapper for __log1pl that handles setting errno.
-   Copyright (C) 2015-2016 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, see
-   <http://www.gnu.org/licenses/>.  */
-
-#include <math_ldbl_opt.h>
-#undef weak_alias
-#define weak_alias(n,a)
-#include <math/w_log1pl.c>
-long_double_symbol (libm, __w_log1pl, log1pl);
-- 
2.4.11