diff --git a/math/Makefile b/math/Makefile
index 121fe2881a..a9fef9e2db 100644
--- a/math/Makefile
+++ b/math/Makefile
@@ -539,6 +539,7 @@ tests = \
   test-tgmath-int \
   test-tgmath-ret \
   test-tgmath2 \
+  test-trunc-except-2 \
   tst-CMPLX \
   tst-CMPLX2 \
   tst-definitions \
@@ -993,6 +994,7 @@ CFLAGS-test-nan-const.c += -fno-builtin
 
 CFLAGS-test-ceil-except-2.c += -fno-builtin
 CFLAGS-test-floor-except-2.c += -fno-builtin
+CFLAGS-test-trunc-except-2.c += -fno-builtin
 
 include ../Rules
 
diff --git a/math/test-trunc-except-2.c b/math/test-trunc-except-2.c
new file mode 100644
index 0000000000..8933c6ab41
--- /dev/null
+++ b/math/test-trunc-except-2.c
@@ -0,0 +1,67 @@
+/* Test trunc functions do not disable exception traps.
+   Copyright (C) 2024 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+#include <fenv.h>
+#include <math.h>
+#include <stdio.h>
+
+#ifndef FE_INEXACT
+# define FE_INEXACT 0
+#endif
+
+#define TEST_FUNC(NAME, FLOAT, SUFFIX)					\
+static int								\
+NAME (void)								\
+{									\
+  int result = 0;							\
+  volatile FLOAT a, b __attribute__ ((unused));				\
+  a = 1.5;								\
+  /* trunc must work when traps on "inexact" are enabled.  */	\
+  b = trunc ## SUFFIX (a);						\
+  /* And it must have left those traps enabled.  */			\
+  if (fegetexcept () == FE_INEXACT)					\
+    puts ("PASS: " #FLOAT);						\
+  else									\
+    {									\
+      puts ("FAIL: " #FLOAT);						\
+      result = 1;							\
+    }									\
+  return result;							\
+}
+
+TEST_FUNC (float_test, float, f)
+TEST_FUNC (double_test, double, )
+TEST_FUNC (ldouble_test, long double, l)
+
+static int
+do_test (void)
+{
+  if (feenableexcept (FE_INEXACT) == -1)
+    {
+      puts ("enabling FE_INEXACT traps failed, cannot test");
+      return 77;
+    }
+  int result = float_test ();
+  feenableexcept (FE_INEXACT);
+  result |= double_test ();
+  feenableexcept (FE_INEXACT);
+  result |= ldouble_test ();
+  return result;
+}
+
+#include <support/test-driver.c>
diff --git a/sysdeps/i386/fpu/s_trunc.S b/sysdeps/i386/fpu/s_trunc.c
similarity index 69%
rename from sysdeps/i386/fpu/s_trunc.S
rename to sysdeps/i386/fpu/s_trunc.c
index 40e45c9f9c..ac16f4967c 100644
--- a/sysdeps/i386/fpu/s_trunc.S
+++ b/sysdeps/i386/fpu/s_trunc.c
@@ -1,5 +1,5 @@
-/* Truncate double value.
-   Copyright (C) 1997-2024 Free Software Foundation, Inc.
+/* Round to integer, toward zero.  i386 version.
+   Copyright (C) 2024 Free Software Foundation, Inc.
    This file is part of the GNU C Library.
 
    The GNU C Library is free software; you can redistribute it and/or
@@ -16,22 +16,10 @@
    License along with the GNU C Library; if not, see
    <https://www.gnu.org/licenses/>.  */
 
-#include <machine/asm.h>
 #include <libm-alias-double.h>
 
-ENTRY(__trunc)
-	fldl	4(%esp)
-	subl	$32, %esp
-	cfi_adjust_cfa_offset (32)
-	fnstenv	4(%esp)
-	movl	$0xc00, %edx
-	orl	4(%esp), %edx
-	movl	%edx, (%esp)
-	fldcw	(%esp)
-	frndint
-	fldenv	4(%esp)
-	addl	$32, %esp
-	cfi_adjust_cfa_offset (-32)
-	ret
-END(__trunc)
+#define FUNC       __trunc
+#define TYPE       double
+#define FE_OPTION  FE_TOWARDZERO
+#include "s_nearestint_387_template.c"
 libm_alias_double (__trunc, trunc)
diff --git a/sysdeps/i386/fpu/s_truncf.S b/sysdeps/i386/fpu/s_truncf.c
similarity index 68%
rename from sysdeps/i386/fpu/s_truncf.S
rename to sysdeps/i386/fpu/s_truncf.c
index 0b26e09d61..240d3507ef 100644
--- a/sysdeps/i386/fpu/s_truncf.S
+++ b/sysdeps/i386/fpu/s_truncf.c
@@ -1,5 +1,5 @@
-/* Truncate float value.
-   Copyright (C) 1997-2024 Free Software Foundation, Inc.
+/* Round to integer, toward zero.  i386 version.
+   Copyright (C) 2024 Free Software Foundation, Inc.
    This file is part of the GNU C Library.
 
    The GNU C Library is free software; you can redistribute it and/or
@@ -16,22 +16,10 @@
    License along with the GNU C Library; if not, see
    <https://www.gnu.org/licenses/>.  */
 
-#include <machine/asm.h>
 #include <libm-alias-float.h>
 
-ENTRY(__truncf)
-	flds	4(%esp)
-	subl	$32, %esp
-	cfi_adjust_cfa_offset (32)
-	fnstenv	4(%esp)
-	movl	$0xc00, %edx
-	orl	4(%esp), %edx
-	movl	%edx, (%esp)
-	fldcw	(%esp)
-	frndint
-	fldenv	4(%esp)
-	addl	$32, %esp
-	cfi_adjust_cfa_offset (-32)
-	ret
-END(__truncf)
+#define FUNC       __truncf
+#define TYPE       float
+#define FE_OPTION  FE_TOWARDZERO
+#include "s_nearestint_387_template.c"
 libm_alias_float (__trunc, trunc)
diff --git a/sysdeps/i386/fpu/s_truncl.S b/sysdeps/i386/fpu/s_truncl.S
deleted file mode 100644
index dfd0ca4a57..0000000000
--- a/sysdeps/i386/fpu/s_truncl.S
+++ /dev/null
@@ -1,40 +0,0 @@
-/* Truncate long double value.
-   Copyright (C) 1997-2024 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, see
-   <https://www.gnu.org/licenses/>.  */
-
-#include <libm-alias-ldouble.h>
-#include <machine/asm.h>
-
-ENTRY(__truncl)
-	fldt	4(%esp)
-	subl	$32, %esp
-	cfi_adjust_cfa_offset (32)
-	fnstenv	4(%esp)
-	movl	$0xc00, %edx
-	orl	4(%esp), %edx
-	movl	%edx, (%esp)
-	fldcw	(%esp)
-	frndint
-	fnstsw
-	andl	$0x1, %eax
-	orl	%eax, 8(%esp)
-	fldenv	4(%esp)
-	addl	$32, %esp
-	cfi_adjust_cfa_offset (-32)
-	ret
-END(__truncl)
-libm_alias_ldouble (__trunc, trunc)
diff --git a/sysdeps/x86_64/fpu/s_truncl.S b/sysdeps/x86/fpu/s_truncl.c
similarity index 70%
rename from sysdeps/x86_64/fpu/s_truncl.S
rename to sysdeps/x86/fpu/s_truncl.c
index e3d64a84e8..e2bac7fa38 100644
--- a/sysdeps/x86_64/fpu/s_truncl.S
+++ b/sysdeps/x86/fpu/s_truncl.c
@@ -1,5 +1,5 @@
-/* Truncate long double value.
-   Copyright (C) 1997-2024 Free Software Foundation, Inc.
+/* Round to integer, toward zero.  x86 version.
+   Copyright (C) 2024 Free Software Foundation, Inc.
    This file is part of the GNU C Library.
 
    The GNU C Library is free software; you can redistribute it and/or
@@ -17,20 +17,9 @@
    <https://www.gnu.org/licenses/>.  */
 
 #include <libm-alias-ldouble.h>
-#include <machine/asm.h>
 
-ENTRY(__truncl)
-	fldt	8(%rsp)
-	fnstenv	-28(%rsp)
-	movl	$0xc00, %edx
-	orl	-28(%rsp), %edx
-	movl	%edx, -32(%rsp)
-	fldcw	-32(%rsp)
-	frndint
-	fnstsw
-	andl	$0x1, %eax
-	orl	%eax, -24(%rsp)
-	fldenv	-28(%rsp)
-	ret
-END(__truncl)
+#define FUNC       __truncl
+#define TYPE       long double
+#define FE_OPTION  FE_TOWARDZERO
+#include "s_nearestint_387_template.c"
 libm_alias_ldouble (__trunc, trunc)